//+------------------------------------------------------------------+
//|                                             All Laguerre RSI.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright   "this is public domain software"
#property link        "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_level1 0.85
#property indicator_level2 0.50
#property indicator_level3 0.15
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//
//

extern string __                   = "Chose timeframes";
extern string timeFrames           = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern double Gama                 = 0.70;
extern int    AppliedPrice         = 0;
extern int    barsPerTimeFrame     = 35;
extern bool   shiftRight           = False;
extern bool   currentFirst         = true; 
extern color  txtColor             = Silver; 
extern color  separatorColor       = DimGray; 

//
//
//
//
//
//

double ExtMapBuffer1[];
double L0[];
double L1[];
double L2[];
double L3[];

//
//
//
//
//

bool   calculating = false;
string IndicatorFileName;
string shortName;
string labels[];
int    periods[];
int    Shift; 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ExtMapBuffer1);
      if (__=="calculateLaguerre")
      {
         IndicatorBuffers(5);
            SetIndexBuffer(1,L0); SetIndexEmptyValue(1,0);
            SetIndexBuffer(2,L1); SetIndexEmptyValue(2,0);
            SetIndexBuffer(3,L2); SetIndexEmptyValue(3,0);
            SetIndexBuffer(4,L3); SetIndexEmptyValue(4,0);
            calculating = true;
         return(0);
      }            

   //
   //
   //
   //
   //
      
      if (shiftRight) Shift = 1;
      else            Shift = 0;
         barsPerTimeFrame = MathMax(barsPerTimeFrame,15);
         shortName = MakeUniqueName("All Laguerre "," ("+DoubleToStr(Gama,2)+")");
                     IndicatorShortName(shortName);
   
   //
   //
   //
   //
   //

      SetIndexShift(0,Shift*(barsPerTimeFrame+1)); SetIndexLabel(0,"Laguerre RSI");
   
   //
   //
   //
   //
   //
      
      timeFrames = StringTrimLeft(StringTrimRight(timeFrames));
      if (StringSubstr(timeFrames,StringLen(timeFrames),1) != ";")
                       timeFrames = StringConcatenate(timeFrames,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(timeFrames,";",s);
         int time;
         string current;
            while (i > 0)
            {
               current = StringSubstr(timeFrames,s,i-s);
               time    = stringToTimeFrame(current);
               if (time > 0) {
                     ArrayResize(labels ,ArraySize(labels)+1);
                     ArrayResize(periods,ArraySize(periods)+1);
                                 labels[ArraySize(labels)-1] = TimeFrameToString(time); 
                                 periods[ArraySize(periods)-1] = time; }
                                 s = i + 1;
                                     i = StringFind(timeFrames,";",s);
            }
      
      //
      //
      //
      //
      //

      if(currentFirst)
         for (i=1;i<ArraySize(periods);i++)
         if (Period()==periods[i])
            {
               string tmpLbl = labels[i];
               int    tmpPer = periods[i];
               
               //
               //
               //
               //
               //
               
               for (int k=i ;k>0; k--)
                     {
                        labels[k]  = labels[k-1];
                        periods[k] = periods[k-1];
                     }                     
               labels[0]  = tmpLbl;
               periods[0] = tmpPer;
            }
   IndicatorFileName = WindowExpertName();
   return(0);
}

//
//
//
//
//

int deinit()
{
   for(int l=0;l<ArraySize(periods);l++) {
         ObjectDelete(shortName+l);
         ObjectDelete(shortName+l+"label");
      }         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
     string separator;
     int    window=WindowFind(shortName);
     int    k=0;


     if (calculating) { CalculateLaguerre(); return(0); }
     
     //
     //
     //
     //
     //
              
            for(int p=0; p<ArraySize(periods);p++)
                  {
                     for(int i=0; i<barsPerTimeFrame;i++,k++)
                           ExtMapBuffer1[k] = iCustom(NULL,periods[p],IndicatorFileName,"calculateLaguerre","",Gama,AppliedPrice,barsPerTimeFrame,0,i);
                           ExtMapBuffer1[k] = EMPTY_VALUE;  k += 1;
                           
                           //
                           //
                           //
                           //
                           //
                           
                           separator = shortName+p;
                           if(ObjectFind(separator)==-1)
                              ObjectCreate(separator,OBJ_TREND,window,0,0);
                              ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
                              ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
                              ObjectSet(separator,OBJPROP_PRICE1,0);
                              ObjectSet(separator,OBJPROP_PRICE2,1);
                              ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
                              ObjectSet(separator,OBJPROP_WIDTH ,2);
                           separator = shortName+p+"label";
                           if(ObjectFind(separator)==-1)
                              ObjectCreate(separator,OBJ_TEXT,window,0,0);
                              ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
                              ObjectSet(separator,OBJPROP_PRICE1,1);            
                              ObjectSetText(separator,labels[p],9,"Arial",txtColor);
                  }

      //
      //
      //
      //
      //
      
      SetIndexDrawBegin(0,Bars-k);
   return(0);
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

void CalculateLaguerre()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      double Price = iMA(NULL,0,1,0,MODE_SMA,AppliedPrice,i);
	   double RSI   = 0.00;
	   double CU    = 0.00;
	   double CD    = 0.00;


         L0[i] = (1.0 - Gama)*Price + Gama*L0[i+1];
      	L1[i] = -Gama*L0[i] + L0[i+1] + Gama*L1[i+1];
   	   L2[i] = -Gama*L1[i] + L1[i+1] + Gama*L2[i+1];
      	L3[i] = -Gama*L2[i] + L2[i+1] + Gama*L3[i+1];

         //
         //
         //
         //
         //
   
      	if (L0[i] >= L1[i])
         			CU = L0[i] - L1[i];
      	else	   CD = L1[i] - L0[i];
      	if (L1[i] >= L2[i])
         			CU = CU + L1[i] - L2[i];
      	else	   CD = CD + L2[i] - L1[i];
      	if (L2[i] >= L3[i])
	          	   CU = CU + L2[i] - L3[i];
      	else	   CD = CD + L3[i] - L2[i];
         if (CU + CD != 0)
                  RSI = CU / (CU + CD) ;
         ExtMapBuffer1[i] = RSI;
   }
}

//
//
//
//
//

int barTime(int a)
{
   if(a<0)
         return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);   
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
       
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         
   return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}